#ifndef __OBJ_FILE_H_INCLUDED__
#define __OBJ_FILE_H_INCLUDED__


//! Common Object File Format ̃t@CNXB
class ObjFile
{
  //===========================================================================
  // J\bh
  //===========================================================================
public:
  //! RXgN^Bobj t@CǂݍށB
  explicit ObjFile(const wchar_t* i_obj_path);
  //! RXgN^B obj f[^Rs[ĕێB
  explicit ObjFile(const void* i_obj_data, size_t i_size);
  //! fXgN^
  virtual ~ObjFile();
  
  //! JǂmFB
  bool IsOpened() const;

  //! V{擾B
  int GetSymbolCount() const;
  //! V{̃|C^擾B
  const IMAGE_SYMBOL* GetSymbolP(int i_index) const;

  //! i_index Ԗ(0-based)̃V{擾B
  const std::string& GetSymbolName(int i_index) const;
  //! i_index Ԗ(0-based)̔CV{擾B
  const std::string& GetUndecoratedName(int i_index) const;
  //! i_index Ԗ(0-based)̃V{CĂ邩ǂׂB
  bool IsDecorated(int i_index) const;

  //! V{O`V{̃CfbNX擾B
  /**
   *  @return ꍇ͂̃V{̃CfbNXBȂꍇ
   *           -1 ԂB
   */
  int FindSymbol(const char* i_symbol_name) const;

  //! i_index Ԗ(0-based)̃ZNVwb_ւ̃|C^擾B
  const IMAGE_SECTION_HEADER* GetSectionHeaderP(int i_index) const;
  //! i_index Ԗ(0-based)̃ZNVf[^ւ̃|C^擾B
  const BYTE* GetSectionDataP(int i_index) const;
  //! i_index Ԗ(0-based)̃V{O`V{ǂׂB
  bool IsExternalSymbol(int i_index) const;
  
  //! i_index Ԗ(0-based)̃ZNV̍Ĕzu̐擾B
  int GetRelocationCount(int i_section_index) const;
  //! i_index Ԗ(0-based)̃ZNV̍Ĕzue[u擾B
  const IMAGE_RELOCATION* GetRelocations(int i_index) const;
  
  //! ĔzulăZNVf[^ׂB
  bool IsEqualSection(
    int           i_section_index,
    const BYTE*   i_data,
    int           i_size
  ) const;
  
  //! i_image_p  i_symbol_index Ԗڂ̃V{̃ZNVTB
  BYTE* FindSymbolData(
    int     i_symbol_index,
    BYTE*   i_image_p,
    size_t  i_image_size
  ) const;

  //===========================================================================
  // J\bh
  //===========================================================================
private:
  //! Rs[RXgN^͎gp֎~ƂB
  ObjFile(const ObjFile&);
  //! Zqgp֎~ƂB
  const ObjFile& operator=(const ObjFile&);
  
  //! |C^ m_obj_data wĂ邩ǂׂB
  bool IsValidPtr(const void* i_ptr, size_t i_size) const;

  //! m_obj_data ̒g͂āAeoɒlZbgB
  void Analyze();
  
  //! C擾B
  static bool UndecorateName(
    std::string&        o_undecorated_name,
    const std::string&  i_decorated_name
  );

  //===========================================================================
  // o
  //===========================================================================
protected:
  bool                      m_is_opened;          //!< f[^ێłH
  std::vector<BYTE>         m_obj_data;           //!< obj t@Cf[^B
  PIMAGE_FILE_HEADER        m_file_header_p;      //!< t@Cwb_ցB
  PIMAGE_SECTION_HEADER     m_section_header_p;   //!< ZNVwb_̐擪B
  PIMAGE_SYMBOL             m_symbols_p;          //!< V{e[u
  std::vector<std::string>  m_symbol_names;       //!< V{e[uB
  std::vector<std::string>  m_undecorated_names;  //!< CV{B
};


#endif
